﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_arrange_listbox
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Enable and disable the appropriate buttons.
        private void lstAnimals_SelectedIndexChanged(object sender, EventArgs e)
        {
            btnUp.Enabled = (lstAnimals.SelectedIndex > 0);
            btnToTop.Enabled = btnUp.Enabled;
            btnDown.Enabled = (lstAnimals.SelectedIndex < lstAnimals.Items.Count - 1);
            btnToBottom.Enabled = btnDown.Enabled;
        }

        // Move the selected item to the top of the list (index 0).
        private void btnToTop_Click(object sender, EventArgs e)
        {
            object item = lstAnimals.SelectedItem;
            lstAnimals.Items.RemoveAt(lstAnimals.SelectedIndex);
            lstAnimals.Items.Insert(0, item);
            lstAnimals.SelectedIndex = 0;
        }

        // Move the selected item up one position.
        private void btnUp_Click(object sender, EventArgs e)
        {
            int index = lstAnimals.SelectedIndex;
            object item = lstAnimals.SelectedItem;
            lstAnimals.Items.RemoveAt(lstAnimals.SelectedIndex);
            lstAnimals.Items.Insert(index - 1, item);
            lstAnimals.SelectedIndex = index - 1;
        }

        // Move the selected item down one position.
        private void btnDown_Click(object sender, EventArgs e)
        {
            int index = lstAnimals.SelectedIndex;
            object item = lstAnimals.SelectedItem;
            lstAnimals.Items.RemoveAt(lstAnimals.SelectedIndex);
            lstAnimals.Items.Insert(index + 1, item);
            lstAnimals.SelectedIndex = index + 1;
        }

        // Move the selected item to the end of the list.
        private void btnToBottom_Click(object sender, EventArgs e)
        {
            object item = lstAnimals.SelectedItem;
            lstAnimals.Items.RemoveAt(lstAnimals.SelectedIndex);
            lstAnimals.Items.Add(item);
            lstAnimals.SelectedIndex = lstAnimals.Items.Count - 1;
        }
    }
}
